﻿using System;
using System.Collections.Generic;
using System.Data.EntityClient;
using System.Diagnostics;
using System.Linq;
using System.Text;
using HuagatiEFProfiler;
using System.IO;



namespace QueryProfilingExamples
{
  partial class AWEntities
  {
    private HuagatiEFProfiler.EFProfiler _profiler = null;

    public AWEntities(bool enableProfiling)
      : this(enableProfiling, "name=AWEntities")
        {
        }

    public AWEntities(bool enableProfiling, string connectionString)
            : this(EFProfiler.GetConnection(enableProfiling, connectionString))
  {
      string profilerOutput =
        System.IO.Path.Combine(System.Environment.GetFolderPath(Environment.SpecialFolder.Personal),
                                                                @"EFProfiler\Samples");
//#if DEBUG
      _profiler=new HuagatiEFProfiler.EFProfiler(this, profilerOutput,
                                                   null,
                                                   HuagatiEFProfiler.ExecutionPlanMode.Actual,
                                                   false);
//#else
////      _profiler = new HuagatiEFProfiler.EFProfiler(this, profilerOutput,
//                                                   new HuagatiEFProfiler.Filters.PageReadFilter(1000),
//                                                   HuagatiEFProfiler.ExecutionPlanMode.Actual,false);
//#endif
      _profiler.LogError += EFProfiler_LogError;
    }

   

    private void EFProfiler_LogError(object sender, EventArgs e)
    {
      HuagatiEFProfiler.LogErrorEventArgs args = (HuagatiEFProfiler.LogErrorEventArgs)e;
      Debug.Assert(false, "Profiler logging failed - " + args.ErrorMessage);
    }
    
    protected override void Dispose(bool disposing)
    {
      if (_profiler != null)
      {
        _profiler.Dispose();
      }
      base.Dispose(disposing);
    }
  }
}
